Subject: Re: [PATCH v3 net-next 2/2] tc: add 'needs_l2' flag to ingress qdisc

From: Jamal Hadi Salim <[email-masked]>
Date: Mon, 13 Apr 2015 10:28:56 -0400

On 04/10/15 18:35, Alexei Starovoitov wrote:

>> To your "bugs" comments:
>> - updating csum; earlier i said i was conflicted it being a
>> useful "feature".
>> You are repeating again that it is a bug. It is not.
>> This action is intended to  mirror or redirect packets, period.
>
> without updating skb->csum act_mirred is breaking csum for
> checksum_complete devices.

Ok, could this then be checked for in dev features flags and
only then recomputed?

> True. The program authors may want to know whether the packet is seen
> on ingress or egress and take different actions inside the program,
> but forcing them to _always_ parse the packet differently because of
> it is not acceptable.

Yes, I see your point here as reasonable dilema. But you could add an
API call the user always make that resets and unsets the header?
It would be a single branch failure for egress/stack source.

cheers,
jamal